"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/SharedSnackbar.tsx
var SharedSnackbar_exports = {};
__export(SharedSnackbar_exports, {
  SharedSnackbar: () => SharedSnackbar,
  default: () => SharedSnackbar_default
});
module.exports = __toCommonJS(SharedSnackbar_exports);
var import_react = require("react");
var import_material = require("@mui/material");
var import_copy_to_clipboard = __toESM(require("copy-to-clipboard"), 1);
var import_jsx_runtime = require("react/jsx-runtime");
var SharedSnackbar = ({ setSnackbar, snackbar }) => {
  const handleActionClick = () => {
    (0, import_copy_to_clipboard.default)(snackbar.message);
    setSnackbar("Copied to clipboard");
  };
  const onCloseSnackbar = (_, reason) => {
    const { onClose = false } = snackbar;
    if (onClose && reason === "clickaway") {
      return;
    }
    setSnackbar("");
  };
  const { maxWidth, onClick = handleActionClick, ...snackProps } = snackbar;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_material.Snackbar,
    {
      ...snackProps,
      anchorOrigin: { vertical: "bottom", horizontal: "center" },
      style: { maxWidth, height: "auto", lineHeight: "28px", padding: 24, whiteSpace: "pre-line" },
      onClick,
      onClose: onCloseSnackbar
    }
  );
};
var areEqual = (prevProps, nextProps) => {
  if (prevProps.snackbar.open != nextProps.snackbar.open || prevProps.snackbar.message != nextProps.snackbar.message) {
    return false;
  }
  return prevProps.snackbar.children != nextProps.snackbar.children;
};
var SharedSnackbar_default = (0, import_react.memo)(SharedSnackbar, areEqual);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SharedSnackbar
});
//# sourceMappingURL=SharedSnackbar.cjs.map