// src/dialogs/ConfirmUpgrade.tsx
import { Button, Dialog, DialogActions, DialogContent, DialogTitle } from "@mui/material";
import { ADDONS } from "@northern.tech/store/constants";
import { jsx, jsxs } from "react/jsx-runtime";
var ConfirmUpgrade = (props) => {
  const { onConfirm, onClose, newPlan, currentPlan, addOns } = props;
  return /* @__PURE__ */ jsxs(Dialog, { open: !!newPlan, children: [
    /* @__PURE__ */ jsxs(DialogTitle, { children: [
      "Upgrade your plan to ",
      newPlan.name
    ] }),
    /* @__PURE__ */ jsxs(DialogContent, { children: [
      /* @__PURE__ */ jsxs("div", { className: "margin-bottom-small", children: [
        "You are currently subscribed to the ",
        /* @__PURE__ */ jsxs("b", { children: [
          "Mender ",
          currentPlan.name
        ] }),
        " plan."
      ] }),
      /* @__PURE__ */ jsxs("div", { className: "margin-bottom-small", children: [
        "Confirm to upgrade to ",
        /* @__PURE__ */ jsxs("b", { children: [
          "Mender ",
          newPlan.name
        ] }),
        ", billed at ",
        newPlan.price,
        ". ",
        /* @__PURE__ */ jsx("br", {}),
        addOns.map((addon) => /* @__PURE__ */ jsxs("div", { children: [
          "The price of your ",
          /* @__PURE__ */ jsxs("b", { children: [
            "Mender ",
            addon.name
          ] }),
          " add-on package will change to ",
          ADDONS[addon.name][newPlan.id].price
        ] }, addon.name))
      ] }),
      /* @__PURE__ */ jsxs("div", { children: [
        "See full details of features and pricing at",
        " ",
        /* @__PURE__ */ jsx("a", { href: "https://mender.io/plans/pricing", target: "_blank", rel: "noreferrer", children: "mender.io/plans/pricing." })
      ] })
    ] }),
    /* @__PURE__ */ jsxs(DialogActions, { children: [
      /* @__PURE__ */ jsx(Button, { onClick: onClose, children: "Cancel" }),
      /* @__PURE__ */ jsx(Button, { color: "secondary", variant: "contained", onClick: onConfirm, children: "Confirm" })
    ] })
  ] });
};
export {
  ConfirmUpgrade
};
//# sourceMappingURL=ConfirmUpgrade.js.map